#!/bin/bash

DIR=`pwd`
echo " Preparing enviroment for  dnl_softswitch installation"
yum -y install epel-release
yum -y install https://download.postgresql.org/pub/repos/yum/reporpms/EL-7-x86_64/pgdg-redhat-repo-latest.noarch.rpm
yum -y install centos-release-scl
yum clean expire-cache
yum -y install python3 python3-pip python3-devel libnetfilter_conntrack postgresql12 postgresql12-devel wget lzma openssl-devel xz-devel gcc libjpeg-turbo-devel ntp python-devel tcpdump wireshark make bzip2-devel sqlite-devel zip expect telnet git ntp redis nginx
# this is for when database is also on same server ---
yum -y install postgresql12-server prefix12 ip4r12 postgresql12-contrib
#---------------------------------------------------------------------#
echo "checking selinux status:"
status=$(getenforce)
if [ $status == Enforcing ]; then
echo "selinux is enabled, setting temporary to permissive"
setenforce permissive
echo "Dont forget to change selinux setting for permament change"
else echo "Selinux is not enabled on this system"
fi
# install php and prerequisites for web ui
# Install nodejs for  web ui
curl --silent --location https://rpm.nodesource.com/setup_12.x | sudo bash -
yum install -y nodejs
ln -s /usr/pgsql-12/bin/pg_config /usr/bin/pg_config
ln -s /usr/pgsql-12/bin/psql /usr/bin/psql

if [ ! -f /usr/bin/wget ]; then
yum -y install wget 
fi
#if [ ! -f /usr/local/bin/python3 ];then
#echo " Installing Python3"
#cd /usr/local/src/
#wget https://www.python.org/ftp/python/3.5.4/Python-3.5.4.tar.xz
#tar xf Python-3.5.4.tar.xz
#cd Python-3.5.4
#./configure
#make
#make install
#/usr/local/bin/pip3 install psycopg2
#/usr/local/bin/pip3 install --upgrade pip
#/usr/local/bin/pip3 install configparser
#/usr/local/bin/pip3 install flask
#/usr/local/bin/pip3 install Flask-WTF
#/usr/local/bin/pip3 install requests
#/usr/local/bin/pip3 install pillow
#/usr/local/bin/pip3 install reportlab
#/usr/local/bin/pip3 install python-dateutil
#/usr/local/bin/pip3 install lockfile
#/usr/local/bin/pip3 install phpserialize
#/usr/local/bin/pip3 install xlrd pytz psutil
#ln -s /usr/local/bin/python3 /usr/bin/python3
#ln -s /usr/local/bin/pip3.5 /usr/bin/pip3
#rm -r /usr/local/src/Python-3.5.4
#pip3 install --upgrade pip
#echo " done setting python3 "
#fi
#/usr/bin/pip install gunicorn flask gcs_client 
#/usr/bin/pip install -U certifi==2015.4.28
mv /etc/localtime /etc/localtime.bak
ln -s /usr/share/zoneinfo/GMT /etc/localtime
echo "enabling and starting network time services"
systemctl start ntpd
systemctl enable ntpd
echo " enter user for which softswitch will be installed to"
read user
id -u $user &>/dev/null|| useradd "$user" -d /opt/$user
chmod 755 /opt/$user
if [ ! -d /opt/$user ]; then
mkdir /opt/$user
chmod 755 /opt/$user
chown -R $user:$user /opt/$user
fi
echo " User is : $user"
echo "enter password for accessing stash.denovolab.com:"
read -s password
pass=$password
#sleep 3
cd /opt
mkdir /opt/$user/install
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/af/falcon_rest.git /opt/$user/install/falcon_rest"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/api_dnl-sdist.git /opt/$user/install/webbackend"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/v6_webui.git /opt/$user/install/jswebui"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/c4sw/backend_binaries.git /opt/$user/install/backend_binaries/"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
cd /opt/$user/install/backend_binaries/
if [ ! -d /opt/$user/web ]; then
mkdir /opt/$user/web
fi
cp -R dnl_softswitch /opt/$user
cp -R dnl_livecall /opt/$user/
cp -R dnl_tools /opt/$user
cp -R dnl_memdb /opt/$user/
cp -R dnl_web_helper /opt/$user
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_softswitch/conf/dnl_softswitch.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_livecall/conf/dnl_livecall.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_memdb/conf/dnl_memdb_info.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_web_helper/conf/dnl_db_info.conf
echo "inserting public ip into softswitch config"
ip=$(ip route get 1 | awk '{print $NF;exit}')
echo "your public ip is:" $ip
sed -i -e 's/lrn_local_ip =/& '$ip'/g' /opt/denovo_v6/dnl_softswitch/conf/dnl_softswitch.conf
sed -i -e 's/license_ip =/& '$ip'/g' /opt/denovo_v6/dnl_softswitch/conf/dnl_softswitch.conf

cd $DIR
adduser webbackend -r
cp -R postgresql.service /etc/systemd/system/
systemctl daemon-reload
echo "Setting up database server"
//#/usr/pgsql-12/bin/postgresql-12-setup initdb postgresql
/usr/pgsql-12/bin/postgresql-12-setup initdb postgresql
systemctl enable postgresql

cd /opt/$user/install/webbackend
sed -i -e 's/peer/trust/g' /opt/pgsql/12/data/pg_hba.conf
sed -i -e 's/ident/trust/g' /opt/pgsql/12/data/pg_hba.conf
systemctl start postgresql
//echo "enter database name for the client (default: class4_dnl)"
//read database
echo "Creating Database"
database = class4_dnl
psql -U postgres -c "create database $database;"
psql -U postgres -c "create user webbackend login superuser password 'shoh6Chahx0Gu9fe';"
psql -U postgres -c "create user class4_user login superuser password '123456';"
psql -U postgres $database < schema/schema.sql
psql -U postgres $database < schema/data.sql
#psql -U postgres $database < schema/class4_update_record.sql
cd $DIR
#cp -R dnl_rt_index /opt/$user/
cd /opt/$user/install/falcon_rest
pip3 install -r requirements.txt
python3 setup.py install

cd /opt/$user/install/webbackend
directory=`pwd`
echo $directory
pip3 install -r requirements.txt
api_dnl=$(ls -v | tail -n 1)
echo $api_dnl
#sudo pip3 install $api_dnl
pip3 install $api_dnl
cp -R $DIR/api.ini /opt/$user/api_dnl/api.ini
sed -i -e 's/localhost/'$ip'/g' /opt/$user/api_dnl/api.ini
#cd /opt/$user/install/jswebui/
#echo "Preparing v6 ui"
#mkdir static
#sed -i -e '/address:/ c \    address: '"'"$ip"'",'' src/config/global.js
#sed -i -e '/address_report:/ c \    address_report: '"'"$ip"'",'' src/config/global.js
#sed -i -e '/address_websocket:/ c \    address_websocket: '"'"$ip"'",'' src/config/global.js
#sed -i -e '/websocket_host:/ c \    websocket_host: '"'"$ip"'",'' src/config/global.js
#npm install
#npm run build
cp -R /opt/$user/install/jswebui/* /opt/$user/web/
echo " $(date) done "
#cd /opt/denovo_v6/api_dnl
#/usr/local/bin/alembic -c alembic.ini upgrade head
chown -R $user:$user /opt/$user
echo "Setting ip_forward and iptables for the proxy media"
echo "net.ipv4.ip_forward = 1" >> /etc/sysctl.conf
sysctl -p /etc/sysctl.conf 
modprobe nf_conntrack 
cd $DIR 
sed -i -e s/default_server//g /etc/nginx/nginx.conf
cp -R denovo.conf /etc/nginx/conf.d/denovo.conf
echo "installing service files "
chown -R root:root denovo_v6_systemd_init_scripts
chown -R webbackend:webbackend /opt/denovo_v6
#chmod 644 ./denovo_v6_systemd_init_scripts/sudoers.d/denovo
systemctl enable redis
systemctl start redis
cp -R denovo_v6_systemd_init_scripts/*.service /etc/systemd/system
systemctl daemon-reload
############################## Softswitch part services  ###############################################################
systemctl enable dnl_livecall.service dnl_softswitch.service dnl_tools.service dnl_webhelper.service dnl_api_dnl dnl_api_dnl_beat dnl_api_dnl_worker dnl_api_dnl_ws_broker nginx
############# Web Part Services ###########################################################
systemctl start dnl_softswitch dnl_tools dnl_livecall dnl_webhelper dnl_api_dnl dnl_api_dnl_beat dnl_api_dnl_worker dnl_api_dnl_ws_broker nginx

echo " Done ! "
