#!/bin/bash

DIR=`pwd`
echo " Preparing enviroment for  dnl_softswitch installation"
yum -y install epel-release
yum -y install https://download.postgresql.org/pub/repos/yum/reporpms/EL-8-x86_64/pgdg-redhat-repo-latest.noarch.rpm
dnf module disable postgresql
#yum -y install scl-release
yum clean expire-cache
yum -y install expect ncurses-compat-libs
yum -y install libnetfilter_conntrack postgresql12 postgresql12-devel wget xz-libs openssl-devel xz-devel gcc libjpeg-turbo-devel python2-devel tcpdump wireshark make bzip2-devel sqlite-devel zip telnet git redis nginx python3-pip python3 python3-devel
# this is for when database is also on same server ---
yum -y install postgresql12-server prefix12 ip4r12 postgresql12-contrib
#---------------------------------------------------------------------#
echo "checking selinux status:"
status=$(getenforce)
if [ $status == Enforcing ]; then
echo "selinux is enabled, setting temporary to permissive"
setenforce permissive
echo "Dont forget to change selinux setting for permament change"
else echo "Selinux is not enabled on this system"
fi
# install php and prerequisites for web ui
# Install nodejs for  web ui
curl --silent --location https://rpm.nodesource.com/setup_12.x | sudo bash -
yum install -y nodejs
ln -s /usr/pgsql-12/bin/pg_config /usr/bin/pg_config
ln -s /usr/pgsql-12/bin/psql /usr/bin/psql

if [ ! -f /usr/bin/wget ]; then
yum -y install wget 
fi
mv /etc/localtime /etc/localtime.bak
ln -s /usr/share/zoneinfo/GMT /etc/localtime
echo "enabling and starting network time services"
systemctl start ntpd
systemctl enable ntpd
#echo " enter user for which softswitch will be installed to"
#read user
#id -u $user &>/dev/null|| useradd "$user" -d /opt/$user
user=denovo_v6
useradd "$user" -d /opt/$user
chmod 755 /opt/$user
if [ ! -d /opt/$user ]; then
mkdir /opt/$user
chmod 755 /opt/$user
chown -R $user:$user /opt/$user
fi
echo " User is : $user"
#echo "enter password for accessing stash.denovolab.com:"
#read -s password
pass=`echo U2FsdGVkX1/43drwJcjvnisCSgilLXbuyCSv2rhLu6Y=| openssl enc -aes-256-cbc -a -d -salt -pass pass:eoirjhlsdkf342`
#sleep 3
cd /opt
mkdir /opt/$user/install
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/af/falcon_rest.git /opt/$user/install/falcon_rest"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/webbackend.git /opt/$user/install/webbackend"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/jswebui.git /opt/$user/install/jswebui"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas4-v5-rel/class4-v5.0.git /opt/$user/install/class4-v5-rel"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
cd /opt/$user/install/class4-v5-rel
if [ ! -d /opt/$user/web ]; then
mkdir /opt/$user/web
fi
cp -R backend/dnl_softswitch /opt/$user
cp -R backend/dnl_livecall /opt/$user/
cp -R backend/dnl_tools /opt/$user
cp -R backend/dnl_memdb /opt/$user/
cp -R backend/dnl_web_helper /opt/$user
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_softswitch/conf/dnl_softswitch.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_livecall/conf/dnl_livecall.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_memdb/conf/dnl_memdb_info.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_web_helper/conf/dnl_db_info.conf
echo "inserting public ip into softswitch config"
ip=$(ip route get 1 | awk '{print $7;exit}')
echo "your public ip is:" $ip
sed -i -e 's/lrn_local_ip =/& '$ip'/g' /opt/denovo_v6/dnl_softswitch/conf/dnl_softswitch.conf
sed -i -e 's/license_ip =/& '$ip'/g' /opt/denovo_v6/dnl_softswitch/conf/dnl_softswitch.conf

cd $DIR
adduser webbackend -r
cp -R postgresql.service /etc/systemd/system/
systemctl daemon-reload
echo "Setting up database server"
/usr/pgsql-11/bin/postgresql-11-setup initdb postgresql
systemctl enable postgresql

cd /opt/$user/install/webbackend
sed -i -e 's/peer/trust/g' /opt/pgsql/11/data/pg_hba.conf
sed -i -e 's/ident/trust/g' /opt/pgsql/11/data/pg_hba.conf
systemctl start postgresql
#echo "enter database name for the client (default: class4_dnl)"
#read database
database=class4_dnl
psql -U postgres -c "create database $database;"
psql -U postgres -c "create user webbackend login superuser password 'shoh6Chahx0Gu9fe';"
psql -U postgres -c "create user class4_user login superuser password '123456';"
psql -U postgres $database < schema/schema.sql
psql -U postgres $database < schema/data.sql
psql -U postgres $database < schema/class4_update_record.sql
cd $DIR
cp -R dnl_rt_index /opt/$user/
cd /opt/$user/install/falcon_rest
pip3 install -r requirements.txt
python3 setup.py install

cd /opt/$user/install/webbackend
directory=`pwd`
echo $directory
pip3 install -r requirements.txt
pip3 install -U dist/api-dnl-head.tar.gz
cp -R $DIR/api.ini /opt/$user/api_dnl/api.ini
sed -i -e 's/localhost/'$ip'/g' /opt/$user/api_dnl/api.ini
cd /opt/$user/install/jswebui/
echo "Preparing v6 ui"
mkdir static
sed -i -e '/address:/ c \    address: '"'"$ip"'",'' src/config/global.js
sed -i -e '/address_report:/ c \    address_report: '"'"$ip"'",'' src/config/global.js
sed -i -e '/address_websocket:/ c \    address_websocket: '"'"$ip"'",'' src/config/global.js
sed -i -e '/websocket_host:/ c \    websocket_host: '"'"$ip"'",'' src/config/global.js
npm install
npm run build
cp -R /opt/$user/install/jswebui/dist/* /opt/$user/web/
echo " $(date) done "
#cd /opt/denovo_v6/api_dnl
#/usr/local/bin/alembic -c alembic.ini upgrade head
chown -R $user:$user /opt/$user
echo "Setting ip_forward and iptables for the proxy media"
echo "net.ipv4.ip_forward = 1" >> /etc/sysctl.conf
sysctl -p /etc/sysctl.conf 
modprobe nf_conntrack 
cd $DIR 
sed -i -e s/default_server//g /etc/nginx/nginx.conf
cp -R denovo.conf /etc/nginx/conf.d/denovo.conf
echo "installing service files "
chown -R root:root denovo_v6_systemd_init_scripts
chown -R webbackend:webbackend /opt/denovo_v6
#chmod 644 ./denovo_v6_systemd_init_scripts/sudoers.d/denovo
systemctl enable redis
systemctl start redis
cp -R denovo_v6_systemd_init_scripts/*.service /etc/systemd/system
systemctl daemon-reload
############################## Softswitch part services  ###############################################################
systemctl enable dnl_livecall.service dnl_softswitch.service dnl_tools.service dnl_webhelper.service dnl_api_dnl dnl_api_dnl_beat dnl_api_dnl_worker dnl_api_dnl_ws_broker nginx
############# Web Part Services ###########################################################
systemctl start dnl_softswitch dnl_tools dnl_livecall dnl_webhelper dnl_api_dnl dnl_api_dnl_beat dnl_api_dnl_worker dnl_api_dnl_ws_broker nginx

echo " Done ! "
