#!/bin/bash

DIR=`pwd`
echo " Preparing enviroment for  dnl_softswitch installation"
yum -y install epel-release
yum -y install https://download.postgresql.org/pub/repos/yum/reporpms/EL-7-x86_64/pgdg-redhat-repo-latest.noarch.rpm
yum clean expire-cache
yum -y install postgresql11 postgresql11-devel wget lzma openssl-devel xz-devel gcc  ntp  zip expect telnet git postgresql11-server prefix11 ip4r11 postgresql11-contrib
echo "checking selinux status:"
status=$(getenforce)
if [ $status == Enforcing ]; then
echo "selinux is enabled, setting temporary to permissive"
setenforce permissive
echo "Dont forget to change selinux setting for permament change"
else echo "Selinux is not enabled on this system"
fi
mv /etc/localtime /etc/localtime.bak
ln -s /usr/share/zoneinfo/GMT /etc/localtime
echo "enabling and starting network time services"
systemctl start ntpd
systemctl enable ntpd
echo "enter password for accessing stash.denovolab.com:"
read -s password
pass=$password
#sleep 3
cd /opt
mkdir /opt/installv6
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/webbackend.git /opt/$user/install/webbackend"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
cd $DIR
cp -R postgresql.service /etc/systemd/system/
systemctl daemon-reload
echo "Setting up database server"
/usr/pgsql-11/bin/postgresql-11-setup initdb postgresql
systemctl enable postgresql

cd /opt/$user/install/webbackend
sed -i -e 's/peer/trust/g' /opt/pgsql/11/data/pg_hba.conf
sed -i -e 's/ident/trust/g' /opt/pgsql/11/data/pg_hba.conf
systemctl start postgresql
#echo "enter database name for the client (default: class4_dnl)"
database=class4_dnl
#read database
psql -U postgres -c "create database $database;"
psql -U postgres -c "create user webbackend login superuser password 'shoh6Chahx0Gu9fe';"
psql -U postgres -c "create user class4_user login superuser password '123456';"
psql -U postgres $database < schema/schema.sql
psql -U postgres $database < schema/data.sql
psql -U postgres $database < schema/class4_update_record.sql

echo " Done ! "
