#!/bin/bash

DIR=`pwd`
echo " Preparing enviroment for  dnl_softswitch installation"
yum -y install epel-release
yum -y install https://download.postgresql.org/pub/repos/yum/reporpms/EL-7-x86_64/pgdg-redhat-repo-latest.noarch.rpm
yum clean expire-cache
yum -y install libnetfilter_conntrack postgresql11 postgresql11-devel wget lzma openssl-devel xz-devel gcc libjpeg-turbo-devel ntp python-devel tcpdump wireshark make bzip2-devel sqlite-devel zip expect telnet git ntp redis nginx
#---------------------------------------------------------------------#
echo "checking selinux status:"
status=$(getenforce)
if [ $status == Enforcing ]; then
echo "selinux is enabled, setting temporary to permissive"
setenforce permissive
echo "Dont forget to change selinux setting for permament change"
else echo "Selinux is not enabled on this system"
fi
# install php and prerequisites for web ui
# Install nodejs for  web ui
curl --silent --location https://rpm.nodesource.com/setup_8.x | sudo bash -
yum install -y nodejs
ln -s /usr/pgsql-11/bin/pg_config /usr/bin/pg_config
ln -s /usr/pgsql-11/bin/psql /usr/bin/psql

if [ ! -f /usr/bin/wget ]; then
yum -y install wget 
fi
if [ ! -f /usr/local/bin/python3 ];then
echo " Installing Python3"
cd /usr/local/src/
wget https://www.python.org/ftp/python/3.5.4/Python-3.5.4.tar.xz
tar xf Python-3.5.4.tar.xz
cd Python-3.5.4
./configure
make
make install
ln -s /usr/local/bin/python3 /usr/bin/python3
ln -s /usr/local/bin/pip3.5 /usr/bin/pip3
rm -r /usr/local/src/Python-3.5.4
pip3 install --upgrade pip
echo " done setting python3 "
fi
mv /etc/localtime /etc/localtime.bak
ln -s /usr/share/zoneinfo/GMT /etc/localtime
echo "enabling and starting network time services"
systemctl start ntpd
systemctl enable ntpd
echo " enter user for which softswitch will be installed to"
read user
id -u $user &>/dev/null|| useradd "$user" -d /opt/$user
chmod 755 /opt/$user
if [ ! -d /opt/$user ]; then
mkdir /opt/$user
chmod 755 /opt/$user
chown -R $user:$user /opt/$user
fi
echo " User is : $user"
echo "enter password for accessing stash.denovolab.com:"
read -s password
pass=$password
#sleep 3
cd /opt
mkdir /opt/$user/install
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/af/falcon_rest.git /opt/$user/install/falcon_rest"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/webbackend.git /opt/$user/install/webbackend"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas6/jswebui.git /opt/$user/install/jswebui"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
/usr/bin/expect <<EOD
set timeout -1
spawn bash -c "git clone http://meda@stash.denovolab.com/scm/clas4-v5-rel/class4-v5.0.git /opt/$user/install/class4-v5-rel"
expect "Password for 'http://meda@stash.denovolab.com':"
send $pass\r
expect eof
EOD
cd /opt/$user/install/class4-v5-rel
if [ ! -d /opt/$user/web ]; then
mkdir /opt/$user/web
fi
cp -R backend/dnl_softswitch /opt/$user
cp -R backend/dnl_livecall /opt/$user/
cp -R backend/dnl_tools /opt/$user
cp -R backend/dnl_memdb /opt/$user/
cp -R backend/dnl_web_helper /opt/$user
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_softswitch/conf/dnl_softswitch.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_livecall/conf/dnl_livecall.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_memdb/conf/dnl_memdb_info.conf
sed -i -e 's/softswitch4v5/class4_dnl/g' /opt/$user/dnl_web_helper/conf/dnl_db_info.conf
echo "inserting public ip into softswitch config"
ip=$(ip route get 1 | awk '{print $NF;exit}')
echo "your public ip is:" $ip
sed -i -e 's/lrn_local_ip =/& '$ip'/g' /opt/denovo_v6/dnl_softswitch/conf/dnl_softswitch.conf
sed -i -e 's/license_ip =/& '$ip'/g' /opt/denovo_v6/dnl_softswitch/conf/dnl_softswitch.conf

cd $DIR
adduser webbackend -r
cp -R postgresql.service /etc/systemd/system/
systemctl daemon-reload

cd $DIR
cd /opt/$user/install/falcon_rest
pip3 install -U requirements.txt
python3 setup.py install

cd /opt/$user/install/webbackend
pip3 install -r requirements.txt
pip3 install -U dist/api-dnl-head.tar.gz
cp -R $DIR/api.ini /opt/$user/api_dnl/api.ini
sed -i -e 's/localhost/'$ip'/g' /opt/$user/api_dnl/api.ini
cd /opt/$user/install/jswebui/
echo "Preparing v6 ui"
mkdir static
sed -i -e '/address:/ c \    address: '"'"$ip"'",'' src/config/global.js
sed -i -e '/address_report:/ c \    address_report: '"'"$ip"'",'' src/config/global.js
sed -i -e '/address_websocket:/ c \    address_websocket: '"'"$ip"'",'' src/config/global.js
sed -i -e '/websocket_host:/ c \    websocket_host: '"'"$ip"'",'' src/config/global.js
npm install
npm run build
cp -R /opt/$user/install/jswebui/dist/* /opt/$user/web/
echo " $(date) done "
#cd /opt/denovo_v6/api_dnl
#/usr/local/bin/alembic -c alembic.ini upgrade head
chown -R $user:$user /opt/$user
echo "Setting ip_forward and iptables for the proxy media"
echo "net.ipv4.ip_forward = 1" >> /etc/sysctl.conf
sysctl -p /etc/sysctl.conf 
modprobe nf_conntrack 
cd $DIR 
sed -i -e s/default_server//g /etc/nginx/nginx.conf
cp -R denovo.conf /etc/nginx/conf.d/denovo.conf
#sed -i -e 
echo "installing service files "
chown -R root:root denovo_v6_systemd_init_scripts
#chmod 644 ./denovo_v6_systemd_init_scripts/sudoers.d/denovo
systemctl enable redis
systemctl start redis
cp -R denovo_v6_systemd_init_scripts/*.service /etc/systemd/system
systemctl daemon-reload
############################## Softswitch part services  ###############################################################
systemctl enable dnl_livecall.service dnl_softswitch.service dnl_tools.service dnl_webhelper.service dnl_api_dnl dnl_api_dnl_beat dnl_api_dnl_worker dnl_api_dnl_ws_broker nginx
############# Web Part Services ###########################################################
systemctl start dnl_softswitch dnl_tools dnl_livecall dnl_webhelper dnl_api_dnl dnl_api_dnl_beat dnl_api_dnl_worker dnl_api_dnl_ws_broker nginx

echo " Done ! "
