alter table resource_ip add column options_ping_inv integer;

drop trigger IF EXISTS class4_trig_record_resource_ip on resource_ip ;
drop table IF EXISTS resource_ip_record;
drop function IF EXISTS class4_trigfun_record_resource_ip();
SELECT * INTO resource_ip_record FROM resource_ip where false;
alter table resource_ip_record add time numeric;
alter table resource_ip_record add flag character(1);
alter table resource_ip_record add record_id serial PRIMARY KEY;
create function class4_trigfun_record_resource_ip() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into resource_ip_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into resource_ip_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into resource_ip_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into resource_ip_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;
create trigger class4_trig_record_resource_ip after update or insert or delete on resource_ip for each row execute procedure class4_trigfun_record_resource_ip();
create index resource_ip_record_time_idx on resource_ip_record using btree (time);

alter table resource add column rate_profile integer ;

drop trigger class4_trig_record_resource on resource;
drop table resource_record;
DROP FUNCTION class4_trigfun_record_resource();
DROP SEQUENCE resource_record_record_id_seq;
SELECT * INTO resource_record FROM resource where false;
alter table resource_record add time numeric;
alter table resource_record add flag character(1);
alter table resource_record add record_id integer;
alter table resource_record alter COLUMN record_id SET NOT NULL;
create SEQUENCE resource_record_record_id_seq;
alter table resource_record alter COLUMN record_id SET DEFAULT nextval('resource_record_record_id_seq'::regclass);

create function class4_trigfun_record_resource() returns trigger as $$
begin
        if(TG_OP='INSERT')then
                insert into resource_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'I';
        elseif(TG_OP='DELETE')then
                insert into resource_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'D';
        elseif(TG_OP='UPDATE')then
                insert into resource_record select OLD.*,EXTRACT(EPOCH from current_timestamp(0)),'B';
                insert into resource_record select NEW.*,EXTRACT(EPOCH from current_timestamp(0)),'A';
        end if;
return null;
end;
$$ language plpgsql;

create trigger class4_trig_record_resource after update or insert or delete on resource for each row execute procedure class4_trigfun_record_resource();

alter table spam_traffic_ip_record  add column netmask  integer ;
